/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTEND
          || GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return 0;
}

int
pattern24 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != 24)
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HQmode:
      if (GET_MODE (x2) != E_HQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_HQmode
          || GET_MODE (x3) != E_HQmode)
        return -1;
      return 0;

    case E_UHQmode:
      if (GET_MODE (x2) != E_UHQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UHQmode
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      return 1;

    case E_HAmode:
      if (GET_MODE (x2) != E_HAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_HAmode
          || GET_MODE (x3) != E_HAmode)
        return -1;
      return 2;

    case E_UHAmode:
      if (GET_MODE (x2) != E_UHAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UHAmode
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern36 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || pattern35 (x1, 
E_SImode, 
22) != 0)
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!low_io_address_operand (operands[0], E_VOIDmode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || GET_MODE (x5) != E_DQmode)
            return -1;
          return 0;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || GET_MODE (x5) != E_DAmode)
            return -1;
          return 1;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || GET_MODE (x5) != E_TAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || !const_operand (operands[0], E_DQmode))
            return -1;
          return 3;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || !const_operand (operands[0], E_DAmode))
            return -1;
          return 4;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || !const_operand (operands[0], E_TAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case NE:
    case EQ:
      operands[0] = x6;
      if (!eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[3] = x7;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTRACT:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XEXP (x8, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x11 = XEXP (x8, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              if (!register_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 0;

                case E_HImode:
                  return 1;

                case E_PSImode:
                  return 2;

                case E_SImode:
                  return 3;

                case E_DImode:
                  return 4;

                default:
                  return -1;
                }

            case MEM:
              if (GET_MODE (x11) != E_QImode)
                return -1;
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 5;

                case E_HImode:
                  return 6;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          switch (GET_MODE (x8))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !single_one_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !single_one_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !single_one_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !single_one_operand (operands[2], E_SImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case LT:
      return 11;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      return pattern138 (x4); /* [-1, 2] */

    case 1:
      res = pattern138 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case 2:
      res = pattern138 (x4);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case 3:
      res = pattern138 (x4);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XINT (x2, 1) != 0
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MINUS
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 32
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 32)
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24
      || GET_MODE (x4) != E_HImode
      || pattern155 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 25
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 36
      || GET_MODE (x8) != E_CCmode)
    return -1;
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x3) != E_DQmode
          || GET_MODE (x4) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x3) != E_UDQmode
          || GET_MODE (x4) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x3) != E_DAmode
          || GET_MODE (x4) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x3) != E_UDAmode
          || GET_MODE (x4) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x3) != E_TAmode
          || GET_MODE (x4) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x3) != E_UTAmode
          || GET_MODE (x4) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x3) != E_HImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern197 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !pseudo_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_SImode
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          res = pattern196 (
E_QImode);
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_HImode:
          res = pattern196 (
E_HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern210 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern220 (x3, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern220 (x3, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern220 (x3, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern220 (x3, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern265 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2)
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  return pattern273 (x1); /* [-1, 1] */
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 22)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  return pattern277 (x1, 
E_QImode, 
21, 
26); /* [-1, 3] */
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[1], E_QImode)
      || !single_zero_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_SQmode:
      if (!register_operand (operands[1], E_SQmode)
          || !nonmemory_operand (operands[2], E_SQmode))
        return -1;
      return 1;

    case E_USQmode:
      if (!register_operand (operands[1], E_USQmode)
          || !nonmemory_operand (operands[2], E_USQmode))
        return -1;
      return 2;

    case E_SAmode:
      if (!register_operand (operands[1], E_SAmode)
          || !nonmemory_operand (operands[2], E_SAmode))
        return -1;
      return 3;

    case E_USAmode:
      if (!register_operand (operands[1], E_USAmode)
          || !nonmemory_operand (operands[2], E_USAmode))
        return -1;
      return 4;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      return 5;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !nonmemory_operand (operands[2], E_HImode))
        return -1;
      return 6;

    case E_HQmode:
      if (!register_operand (operands[1], E_HQmode)
          || !nonmemory_operand (operands[2], E_HQmode))
        return -1;
      return 7;

    case E_UHQmode:
      if (!register_operand (operands[1], E_UHQmode)
          || !nonmemory_operand (operands[2], E_UHQmode))
        return -1;
      return 8;

    case E_HAmode:
      if (!register_operand (operands[1], E_HAmode)
          || !nonmemory_operand (operands[2], E_HAmode))
        return -1;
      return 9;

    case E_UHAmode:
      if (!register_operand (operands[1], E_UHAmode)
          || !nonmemory_operand (operands[2], E_UHAmode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!l_register_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  return 0;
}

int
pattern333 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern336 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!pseudo_register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!pseudo_register_operand (operands[1], E_PSImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!pseudo_register_operand (operands[2], E_PSImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!pseudo_register_operand (operands[3], E_PSImode))
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != E_PSImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case GE:
      return pattern346 (x4); /* [-1, 0] */

    case LT:
      if (pattern346 (x4) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_CODE (x1))
    {
    case CTZ:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 22
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case FFS:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 22
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern359 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern366 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != COMPARE
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  return 0;
}

int
pattern376 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !l_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_CODE (x2))
    {
    case XOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 0;

    case IOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 1;

    case AND:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern387 (x1); /* [-1, 0] */

    case NE:
      if (pattern387 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern387 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern387 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern387 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern387 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      if (pattern69 (x1) == 0)
        return 182; /* *addhi3_zero_extend1_split */
      break;

    default:
      break;
    }
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern72 (x1))
    {
    case 0:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3166; /* adddi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3173; /* *adddi3_insn */

    case 1:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3167; /* adddq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3174; /* *adddq3_insn */

    case 2:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3168; /* addudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3175; /* *addudq3_insn */

    case 3:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3169; /* addda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3176; /* *addda3_insn */

    case 4:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3170; /* adduda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3177; /* *adduda3_insn */

    case 5:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3171; /* addta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3178; /* *addta3_insn */

    case 6:
      if (
#line 101 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3172; /* adduta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3179; /* *adduta3_insn */

    case 7:
      if (
#line 122 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3180; /* adddi3_const8_insn */
      if (pnum_clobbers == NULL
          || !
#line 135 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3181; /* *adddi3_const8_insn */

    case 8:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3182; /* adddi3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3189; /* *adddi3_const_insn */

    case 9:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3183; /* adddq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3190; /* *adddq3_const_insn */

    case 10:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3184; /* addudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3191; /* *addudq3_const_insn */

    case 11:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3185; /* addda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3192; /* *addda3_const_insn */

    case 12:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3186; /* adduda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3193; /* *adduda3_const_insn */

    case 13:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3187; /* addta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3194; /* *addta3_const_insn */

    case 14:
      if (
#line 147 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3188; /* adduta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3195; /* *adduta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern214 (x2) != 0)
        return -1;
      if (
#line 2538 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 486; /* *osmulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2551 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 487; /* *osmulqihi3 */

    case ZERO_EXTEND:
      if (pattern214 (x2) != 0)
        return -1;
      if (
#line 2562 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 488; /* *oumulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2575 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 489; /* *oumulqihi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          if (
#line 3201 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 535; /* muloqihi3 */
          if (pnum_clobbers == NULL
              || !
#line 3214 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 536; /* *muloqihi3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || !pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_HImode
              || !pseudo_register_operand (operands[1], E_HImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_SImode)
              || !
#line 3594 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 547; /* *mulohisi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (pattern164 (x1) == 0)
    return 642; /* *rotlqi3_split */
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (XWINT (x3, 0))
    {
    case 1L:
      switch (pattern202 (x2))
        {
        case 0:
          return 644; /* *rotlhi2.1_split */

        case 1:
          return 648; /* *rotlpsi2.1_split */

        case 2:
          return 652; /* *rotlsi2.1_split */

        default:
          break;
        }
      break;

    case 15L:
      if (register_operand (operands[0], E_HImode)
          && GET_MODE (x2) == E_HImode
          && register_operand (operands[1], E_HImode))
        return 646; /* *rotlhi2.15_split */
      break;

    case 23L:
      if (register_operand (operands[0], E_PSImode)
          && GET_MODE (x2) == E_PSImode
          && register_operand (operands[1], E_PSImode))
        return 650; /* *rotlpsi2.23_split */
      break;

    case 31L:
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && register_operand (operands[1], E_SImode))
        return 654; /* *rotlsi2.31_split */
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (
#line 5232 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 656; /* *rotwhi */
        }
      if (!
#line 5255 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 658; /* *rotbhi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 5232 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 657; /* *rotwsi */
        }
      if (!
#line 5255 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 660; /* *rotbsi */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5255 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 659; /* *rotbpsi */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern192 (x2, 
E_QImode) == 0)
            return 634; /* xorqi3 */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && pattern61 (x2, 
E_HImode) == 0)
            {
              *pnum_clobbers = 1;
              return 636; /* xorhi3 */
            }
          break;

        case E_PSImode:
          if (pattern53 (x2, pnum_clobbers, 
E_PSImode) == 0)
            {
              *pnum_clobbers = 1;
              return 638; /* xorpsi3 */
            }
          break;

        case E_SImode:
          if (pnum_clobbers != NULL
              && pattern61 (x2, 
E_SImode) == 0)
            {
              *pnum_clobbers = 1;
              return 640; /* xorsi3 */
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode)
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 1087; /* *insv.xor1-bit.0_split */

    case LSHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern81 (x2))
        {
        case 0:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1092; /* *xorhi.lshiftrt */

        case 1:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1096; /* *xorpsi.lshiftrt */

        case 2:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1100; /* *xorsi.lshiftrt */

        case 3:
          if (!
#line 10988 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (XOR, operands)))
            return -1;
          return 1479; /* *nzb=1.xor.lsr_split */

        case 4:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1116; /* *xorhiqi.lshiftrt */

        case 5:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1120; /* *xorpsiqi.lshiftrt */

        case 6:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1128; /* *xorpsihi.lshiftrt */

        case 7:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1124; /* *xorsiqi.lshiftrt */

        case 8:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1132; /* *xorsihi.lshiftrt */

        case 9:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1136; /* *xorsipsi.lshiftrt */

        case 10:
          if (!
#line 11038 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (XOR, operands)))
            return -1;
          return 1485; /* *nzb=1.xor.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1094; /* *xorhi.ashift */

        case 1:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1098; /* *xorpsi.ashift */

        case 2:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1102; /* *xorsi.ashift */

        case 3:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1118; /* *xorhiqi.ashift */

        case 4:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1122; /* *xorpsiqi.ashift */

        case 5:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1130; /* *xorpsihi.ashift */

        case 6:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1126; /* *xorsiqi.ashift */

        case 7:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1134; /* *xorsihi.ashift */

        case 8:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1138; /* *xorsipsi.ashift */

        case 9:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1373; /* *shl.ext.and1-to-skip.hi */

        case 10:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1379; /* *shl.ext.and1-to-skip.psi */

        case 11:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1391; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1385; /* *shl.ext.and1-to-skip.si */

        case 13:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1397; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1403; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1372; /* *shl.ext.and1-to-skip.hi */

        case 16:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1378; /* *shl.ext.and1-to-skip.psi */

        case 17:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1390; /* *shl.ext.and1-to-skip.psi */

        case 18:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1384; /* *shl.ext.and1-to-skip.si */

        case 19:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1396; /* *shl.ext.and1-to-skip.si */

        case 20:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1402; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          return 1104; /* *xorhiqi.0 */

        case 1:
          return 1106; /* *xorpsiqi.0 */

        case 2:
          return 1110; /* *xorpsihi.0 */

        case 3:
          return 1108; /* *xorsiqi.0 */

        case 4:
          return 1112; /* *xorsihi.0 */

        case 5:
          return 1114; /* *xorsipsi.0 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1274; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1286; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1298; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1310; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1277; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1289; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1301; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1313; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1280; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1292; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1304; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1316; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1283; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1295; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1307; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1319; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1406; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1409; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1412; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1322; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1325; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1328; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1331; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1336; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1342; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1354; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1348; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1360; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1366; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1337; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1343; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1355; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1349; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1361; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1367; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10943 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (XOR == IOR || XOR == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1473; /* *nzb=1.xor.zerox_split */

        case 1:
          if (!
#line 11012 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (XOR == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1482; /* *nzb=1.xor.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11062 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (XOR == IOR || XOR == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1488; /* *nzb=1.xor.ge0_split */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern64 (x3))
    {
    case 0:
      return 3037; /* ussubuqq3 */

    case 1:
      return 3039; /* ussubuhq3 */

    case 2:
      return 3041; /* ussubuha3 */

    case 3:
      return 3043; /* ussubusa3 */

    case 4:
      return 3045; /* ussubusq3 */

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern65 (x1))
    {
    case 0:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3249; /* ussubudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3255; /* *ussubudq3_insn */

    case 1:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3251; /* ussubuda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3257; /* *ussubuda3_insn */

    case 2:
      if (
#line 361 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3253; /* ussubuta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3259; /* *ussubuta3_insn */

    case 3:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3261; /* ussubudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3267; /* *ussubudq3_const_insn */

    case 4:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3263; /* ussubuda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3269; /* *ussubuda3_const_insn */

    case 5:
      if (
#line 382 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3265; /* ussubuta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3271; /* *ussubuta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern301 (x3) != 0
              || GET_MODE (x4) != E_HImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 2478 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 481; /* umulqihi3 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode)
            return -1;
          x8 = XEXP (x3, 0);
          if (GET_MODE (x8) != E_PSImode
              || GET_MODE (x4) != E_PSImode)
            return -1;
          x9 = XEXP (x8, 0);
          switch (GET_MODE (x9))
            {
            case E_QImode:
              operands[1] = x9;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 4121 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 597; /* *umulqihipsi3 */

            case E_HImode:
              operands[2] = x9;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 4148 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 599; /* *umulhiqipsi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2501 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 483; /* *usmulqihi3 */

    case CONST_INT:
      operands[2] = x4;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      if (u8_operand (operands[2], E_HImode)
          && 
#line 2994 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 522; /* *muluqihi3.uconst */
      if (!s8_operand (operands[2], E_HImode)
          || !
#line 3012 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 523; /* *muluqihi3.sconst */

    case REG:
    case SUBREG:
      if (pattern223 (x1) != 0
          || pattern301 (x3) != 0
          || !
#line 3187 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 534; /* *muluqihi3 */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_CCNmode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != E_CCNmode)
    return -1;
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  switch (GET_MODE (x8))
    {
    case E_HImode:
      if (pattern366 (x3, 
E_HImode) != 0
          || !
#line 7537 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 937; /* *ashift.for.ccn.hi */

    case E_PSImode:
      if (pattern366 (x3, 
E_PSImode) != 0
          || !
#line 7537 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 938; /* *ashift.for.ccn.psi */

    case E_SImode:
      if (pattern366 (x3, 
E_SImode) != 0
          || !
#line 7537 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 939; /* *ashift.for.ccn.si */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode
   && reload_completed))
        return -1;
      return 1876; /* *fractuqqqq2 */

    case 1:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QQmode
   && reload_completed))
        return -1;
      return 1877; /* *fracthqqq2 */

    case 2:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode
   && reload_completed))
        return -1;
      return 1878; /* *fractuhqqq2 */

    case 3:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QQmode
   && reload_completed))
        return -1;
      return 1879; /* *fracthaqq2 */

    case 4:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode
   && reload_completed))
        return -1;
      return 1880; /* *fractuhaqq2 */

    case 5:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QQmode
   && reload_completed))
        return -1;
      return 1881; /* *fractsqqq2 */

    case 6:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QQmode
   && reload_completed))
        return -1;
      return 1882; /* *fractusqqq2 */

    case 7:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QQmode
   && reload_completed))
        return -1;
      return 1883; /* *fractsaqq2 */

    case 8:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QQmode
   && reload_completed))
        return -1;
      return 1884; /* *fractusaqq2 */

    case 9:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QQmode
   && reload_completed))
        return -1;
      return 1885; /* *fractdqqq2 */

    case 10:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode
   && reload_completed))
        return -1;
      return 1886; /* *fractudqqq2 */

    case 11:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QQmode
   && reload_completed))
        return -1;
      return 1887; /* *fractdaqq2 */

    case 12:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode
   && reload_completed))
        return -1;
      return 1888; /* *fractudaqq2 */

    case 13:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QQmode
   && reload_completed))
        return -1;
      return 1889; /* *fracttaqq2 */

    case 14:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode
   && reload_completed))
        return -1;
      return 1890; /* *fractutaqq2 */

    case 15:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != QQmode
   && reload_completed))
        return -1;
      return 1891; /* *fractqiqq2 */

    case 16:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != QQmode
   && reload_completed))
        return -1;
      return 1892; /* *fracthiqq2 */

    case 17:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != QQmode
   && reload_completed))
        return -1;
      return 1893; /* *fractsiqq2 */

    case 18:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != QQmode
   && reload_completed))
        return -1;
      return 1894; /* *fractdiqq2 */

    case 19:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode
   && reload_completed))
        return -1;
      return 1895; /* *fractqquqq2 */

    case 20:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode
   && reload_completed))
        return -1;
      return 1896; /* *fracthquqq2 */

    case 21:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode
   && reload_completed))
        return -1;
      return 1897; /* *fractuhquqq2 */

    case 22:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode
   && reload_completed))
        return -1;
      return 1898; /* *fracthauqq2 */

    case 23:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode
   && reload_completed))
        return -1;
      return 1899; /* *fractuhauqq2 */

    case 24:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode
   && reload_completed))
        return -1;
      return 1900; /* *fractsquqq2 */

    case 25:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode
   && reload_completed))
        return -1;
      return 1901; /* *fractusquqq2 */

    case 26:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode
   && reload_completed))
        return -1;
      return 1902; /* *fractsauqq2 */

    case 27:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode
   && reload_completed))
        return -1;
      return 1903; /* *fractusauqq2 */

    case 28:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode
   && reload_completed))
        return -1;
      return 1904; /* *fractdquqq2 */

    case 29:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode
   && reload_completed))
        return -1;
      return 1905; /* *fractudquqq2 */

    case 30:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode
   && reload_completed))
        return -1;
      return 1906; /* *fractdauqq2 */

    case 31:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode
   && reload_completed))
        return -1;
      return 1907; /* *fractudauqq2 */

    case 32:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode
   && reload_completed))
        return -1;
      return 1908; /* *fracttauqq2 */

    case 33:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode
   && reload_completed))
        return -1;
      return 1909; /* *fractutauqq2 */

    case 34:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UQQmode
   && reload_completed))
        return -1;
      return 1910; /* *fractqiuqq2 */

    case 35:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UQQmode
   && reload_completed))
        return -1;
      return 1911; /* *fracthiuqq2 */

    case 36:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UQQmode
   && reload_completed))
        return -1;
      return 1912; /* *fractsiuqq2 */

    case 37:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UQQmode
   && reload_completed))
        return -1;
      return 1913; /* *fractdiuqq2 */

    case 38:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HQmode
   && reload_completed))
        return -1;
      return 1914; /* *fractqqhq2 */

    case 39:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode
   && reload_completed))
        return -1;
      return 1915; /* *fractuqqhq2 */

    case 40:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode
   && reload_completed))
        return -1;
      return 1916; /* *fractuhqhq2 */

    case 41:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HQmode
   && reload_completed))
        return -1;
      return 1917; /* *fracthahq2 */

    case 42:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode
   && reload_completed))
        return -1;
      return 1918; /* *fractuhahq2 */

    case 43:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HQmode
   && reload_completed))
        return -1;
      return 1919; /* *fractsqhq2 */

    case 44:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HQmode
   && reload_completed))
        return -1;
      return 1920; /* *fractusqhq2 */

    case 45:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HQmode
   && reload_completed))
        return -1;
      return 1921; /* *fractsahq2 */

    case 46:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HQmode
   && reload_completed))
        return -1;
      return 1922; /* *fractusahq2 */

    case 47:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HQmode
   && reload_completed))
        return -1;
      return 1923; /* *fractdqhq2 */

    case 48:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode
   && reload_completed))
        return -1;
      return 1924; /* *fractudqhq2 */

    case 49:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HQmode
   && reload_completed))
        return -1;
      return 1925; /* *fractdahq2 */

    case 50:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode
   && reload_completed))
        return -1;
      return 1926; /* *fractudahq2 */

    case 51:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HQmode
   && reload_completed))
        return -1;
      return 1927; /* *fracttahq2 */

    case 52:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode
   && reload_completed))
        return -1;
      return 1928; /* *fractutahq2 */

    case 53:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HQmode
   && reload_completed))
        return -1;
      return 1929; /* *fractqihq2 */

    case 54:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != HQmode
   && reload_completed))
        return -1;
      return 1930; /* *fracthihq2 */

    case 55:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HQmode
   && reload_completed))
        return -1;
      return 1931; /* *fractsihq2 */

    case 56:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HQmode
   && reload_completed))
        return -1;
      return 1932; /* *fractdihq2 */

    case 57:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode
   && reload_completed))
        return -1;
      return 1933; /* *fractqquhq2 */

    case 58:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode
   && reload_completed))
        return -1;
      return 1934; /* *fractuqquhq2 */

    case 59:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode
   && reload_completed))
        return -1;
      return 1935; /* *fracthquhq2 */

    case 60:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode
   && reload_completed))
        return -1;
      return 1936; /* *fracthauhq2 */

    case 61:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode
   && reload_completed))
        return -1;
      return 1937; /* *fractuhauhq2 */

    case 62:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode
   && reload_completed))
        return -1;
      return 1938; /* *fractsquhq2 */

    case 63:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode
   && reload_completed))
        return -1;
      return 1939; /* *fractusquhq2 */

    case 64:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode
   && reload_completed))
        return -1;
      return 1940; /* *fractsauhq2 */

    case 65:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode
   && reload_completed))
        return -1;
      return 1941; /* *fractusauhq2 */

    case 66:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode
   && reload_completed))
        return -1;
      return 1942; /* *fractdquhq2 */

    case 67:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode
   && reload_completed))
        return -1;
      return 1943; /* *fractudquhq2 */

    case 68:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode
   && reload_completed))
        return -1;
      return 1944; /* *fractdauhq2 */

    case 69:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode
   && reload_completed))
        return -1;
      return 1945; /* *fractudauhq2 */

    case 70:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode
   && reload_completed))
        return -1;
      return 1946; /* *fracttauhq2 */

    case 71:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode
   && reload_completed))
        return -1;
      return 1947; /* *fractutauhq2 */

    case 72:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHQmode
   && reload_completed))
        return -1;
      return 1948; /* *fractqiuhq2 */

    case 73:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHQmode
   && reload_completed))
        return -1;
      return 1949; /* *fracthiuhq2 */

    case 74:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHQmode
   && reload_completed))
        return -1;
      return 1950; /* *fractsiuhq2 */

    case 75:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHQmode
   && reload_completed))
        return -1;
      return 1951; /* *fractdiuhq2 */

    case 76:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HAmode
   && reload_completed))
        return -1;
      return 1952; /* *fractqqha2 */

    case 77:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode
   && reload_completed))
        return -1;
      return 1953; /* *fractuqqha2 */

    case 78:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HAmode
   && reload_completed))
        return -1;
      return 1954; /* *fracthqha2 */

    case 79:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode
   && reload_completed))
        return -1;
      return 1955; /* *fractuhqha2 */

    case 80:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode
   && reload_completed))
        return -1;
      return 1956; /* *fractuhaha2 */

    case 81:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HAmode
   && reload_completed))
        return -1;
      return 1957; /* *fractsqha2 */

    case 82:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HAmode
   && reload_completed))
        return -1;
      return 1958; /* *fractusqha2 */

    case 83:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HAmode
   && reload_completed))
        return -1;
      return 1959; /* *fractsaha2 */

    case 84:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HAmode
   && reload_completed))
        return -1;
      return 1960; /* *fractusaha2 */

    case 85:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HAmode
   && reload_completed))
        return -1;
      return 1961; /* *fractdqha2 */

    case 86:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode
   && reload_completed))
        return -1;
      return 1962; /* *fractudqha2 */

    case 87:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HAmode
   && reload_completed))
        return -1;
      return 1963; /* *fractdaha2 */

    case 88:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode
   && reload_completed))
        return -1;
      return 1964; /* *fractudaha2 */

    case 89:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HAmode
   && reload_completed))
        return -1;
      return 1965; /* *fracttaha2 */

    case 90:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode
   && reload_completed))
        return -1;
      return 1966; /* *fractutaha2 */

    case 91:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HAmode
   && reload_completed))
        return -1;
      return 1967; /* *fractqiha2 */

    case 92:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != HAmode
   && reload_completed))
        return -1;
      return 1968; /* *fracthiha2 */

    case 93:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HAmode
   && reload_completed))
        return -1;
      return 1969; /* *fractsiha2 */

    case 94:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HAmode
   && reload_completed))
        return -1;
      return 1970; /* *fractdiha2 */

    case 95:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode
   && reload_completed))
        return -1;
      return 1971; /* *fractqquha2 */

    case 96:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode
   && reload_completed))
        return -1;
      return 1972; /* *fractuqquha2 */

    case 97:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode
   && reload_completed))
        return -1;
      return 1973; /* *fracthquha2 */

    case 98:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode
   && reload_completed))
        return -1;
      return 1974; /* *fractuhquha2 */

    case 99:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode
   && reload_completed))
        return -1;
      return 1975; /* *fracthauha2 */

    case 100:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode
   && reload_completed))
        return -1;
      return 1976; /* *fractsquha2 */

    case 101:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode
   && reload_completed))
        return -1;
      return 1977; /* *fractusquha2 */

    case 102:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode
   && reload_completed))
        return -1;
      return 1978; /* *fractsauha2 */

    case 103:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode
   && reload_completed))
        return -1;
      return 1979; /* *fractusauha2 */

    case 104:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode
   && reload_completed))
        return -1;
      return 1980; /* *fractdquha2 */

    case 105:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode
   && reload_completed))
        return -1;
      return 1981; /* *fractudquha2 */

    case 106:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode
   && reload_completed))
        return -1;
      return 1982; /* *fractdauha2 */

    case 107:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode
   && reload_completed))
        return -1;
      return 1983; /* *fractudauha2 */

    case 108:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode
   && reload_completed))
        return -1;
      return 1984; /* *fracttauha2 */

    case 109:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode
   && reload_completed))
        return -1;
      return 1985; /* *fractutauha2 */

    case 110:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHAmode
   && reload_completed))
        return -1;
      return 1986; /* *fractqiuha2 */

    case 111:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHAmode
   && reload_completed))
        return -1;
      return 1987; /* *fracthiuha2 */

    case 112:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHAmode
   && reload_completed))
        return -1;
      return 1988; /* *fractsiuha2 */

    case 113:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHAmode
   && reload_completed))
        return -1;
      return 1989; /* *fractdiuha2 */

    case 114:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SQmode
   && reload_completed))
        return -1;
      return 1990; /* *fractqqsq2 */

    case 115:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode
   && reload_completed))
        return -1;
      return 1991; /* *fractuqqsq2 */

    case 116:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SQmode
   && reload_completed))
        return -1;
      return 1992; /* *fracthqsq2 */

    case 117:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode
   && reload_completed))
        return -1;
      return 1993; /* *fractuhqsq2 */

    case 118:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SQmode
   && reload_completed))
        return -1;
      return 1994; /* *fracthasq2 */

    case 119:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode
   && reload_completed))
        return -1;
      return 1995; /* *fractuhasq2 */

    case 120:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SQmode
   && reload_completed))
        return -1;
      return 1996; /* *fractusqsq2 */

    case 121:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SQmode
   && reload_completed))
        return -1;
      return 1997; /* *fractsasq2 */

    case 122:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SQmode
   && reload_completed))
        return -1;
      return 1998; /* *fractusasq2 */

    case 123:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SQmode
   && reload_completed))
        return -1;
      return 1999; /* *fractdqsq2 */

    case 124:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode
   && reload_completed))
        return -1;
      return 2000; /* *fractudqsq2 */

    case 125:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SQmode
   && reload_completed))
        return -1;
      return 2001; /* *fractdasq2 */

    case 126:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode
   && reload_completed))
        return -1;
      return 2002; /* *fractudasq2 */

    case 127:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SQmode
   && reload_completed))
        return -1;
      return 2003; /* *fracttasq2 */

    case 128:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode
   && reload_completed))
        return -1;
      return 2004; /* *fractutasq2 */

    case 129:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SQmode
   && reload_completed))
        return -1;
      return 2005; /* *fractqisq2 */

    case 130:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SQmode
   && reload_completed))
        return -1;
      return 2006; /* *fracthisq2 */

    case 131:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != SQmode
   && reload_completed))
        return -1;
      return 2007; /* *fractsisq2 */

    case 132:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SQmode
   && reload_completed))
        return -1;
      return 2008; /* *fractdisq2 */

    case 133:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USQmode
   && reload_completed))
        return -1;
      return 2009; /* *fractqqusq2 */

    case 134:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode
   && reload_completed))
        return -1;
      return 2010; /* *fractuqqusq2 */

    case 135:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USQmode
   && reload_completed))
        return -1;
      return 2011; /* *fracthqusq2 */

    case 136:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode
   && reload_completed))
        return -1;
      return 2012; /* *fractuhqusq2 */

    case 137:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USQmode
   && reload_completed))
        return -1;
      return 2013; /* *fracthausq2 */

    case 138:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode
   && reload_completed))
        return -1;
      return 2014; /* *fractuhausq2 */

    case 139:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USQmode
   && reload_completed))
        return -1;
      return 2015; /* *fractsqusq2 */

    case 140:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USQmode
   && reload_completed))
        return -1;
      return 2016; /* *fractsausq2 */

    case 141:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != USQmode
   && reload_completed))
        return -1;
      return 2017; /* *fractusausq2 */

    case 142:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USQmode
   && reload_completed))
        return -1;
      return 2018; /* *fractdqusq2 */

    case 143:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode
   && reload_completed))
        return -1;
      return 2019; /* *fractudqusq2 */

    case 144:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USQmode
   && reload_completed))
        return -1;
      return 2020; /* *fractdausq2 */

    case 145:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode
   && reload_completed))
        return -1;
      return 2021; /* *fractudausq2 */

    case 146:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USQmode
   && reload_completed))
        return -1;
      return 2022; /* *fracttausq2 */

    case 147:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode
   && reload_completed))
        return -1;
      return 2023; /* *fractutausq2 */

    case 148:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != USQmode
   && reload_completed))
        return -1;
      return 2024; /* *fractqiusq2 */

    case 149:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != USQmode
   && reload_completed))
        return -1;
      return 2025; /* *fracthiusq2 */

    case 150:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != USQmode
   && reload_completed))
        return -1;
      return 2026; /* *fractsiusq2 */

    case 151:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != USQmode
   && reload_completed))
        return -1;
      return 2027; /* *fractdiusq2 */

    case 152:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SAmode
   && reload_completed))
        return -1;
      return 2028; /* *fractqqsa2 */

    case 153:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode
   && reload_completed))
        return -1;
      return 2029; /* *fractuqqsa2 */

    case 154:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SAmode
   && reload_completed))
        return -1;
      return 2030; /* *fracthqsa2 */

    case 155:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode
   && reload_completed))
        return -1;
      return 2031; /* *fractuhqsa2 */

    case 156:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SAmode
   && reload_completed))
        return -1;
      return 2032; /* *fracthasa2 */

    case 157:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode
   && reload_completed))
        return -1;
      return 2033; /* *fractuhasa2 */

    case 158:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SAmode
   && reload_completed))
        return -1;
      return 2034; /* *fractsqsa2 */

    case 159:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SAmode
   && reload_completed))
        return -1;
      return 2035; /* *fractusqsa2 */

    case 160:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SAmode
   && reload_completed))
        return -1;
      return 2036; /* *fractusasa2 */

    case 161:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SAmode
   && reload_completed))
        return -1;
      return 2037; /* *fractdqsa2 */

    case 162:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode
   && reload_completed))
        return -1;
      return 2038; /* *fractudqsa2 */

    case 163:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SAmode
   && reload_completed))
        return -1;
      return 2039; /* *fractdasa2 */

    case 164:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode
   && reload_completed))
        return -1;
      return 2040; /* *fractudasa2 */

    case 165:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SAmode
   && reload_completed))
        return -1;
      return 2041; /* *fracttasa2 */

    case 166:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode
   && reload_completed))
        return -1;
      return 2042; /* *fractutasa2 */

    case 167:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SAmode
   && reload_completed))
        return -1;
      return 2043; /* *fractqisa2 */

    case 168:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SAmode
   && reload_completed))
        return -1;
      return 2044; /* *fracthisa2 */

    case 169:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != SAmode
   && reload_completed))
        return -1;
      return 2045; /* *fractsisa2 */

    case 170:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SAmode
   && reload_completed))
        return -1;
      return 2046; /* *fractdisa2 */

    case 171:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USAmode
   && reload_completed))
        return -1;
      return 2047; /* *fractqqusa2 */

    case 172:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode
   && reload_completed))
        return -1;
      return 2048; /* *fractuqqusa2 */

    case 173:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USAmode
   && reload_completed))
        return -1;
      return 2049; /* *fracthqusa2 */

    case 174:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode
   && reload_completed))
        return -1;
      return 2050; /* *fractuhqusa2 */

    case 175:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USAmode
   && reload_completed))
        return -1;
      return 2051; /* *fracthausa2 */

    case 176:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode
   && reload_completed))
        return -1;
      return 2052; /* *fractuhausa2 */

    case 177:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USAmode
   && reload_completed))
        return -1;
      return 2053; /* *fractsqusa2 */

    case 178:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != USAmode
   && reload_completed))
        return -1;
      return 2054; /* *fractusqusa2 */

    case 179:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USAmode
   && reload_completed))
        return -1;
      return 2055; /* *fractsausa2 */

    case 180:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USAmode
   && reload_completed))
        return -1;
      return 2056; /* *fractdqusa2 */

    case 181:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode
   && reload_completed))
        return -1;
      return 2057; /* *fractudqusa2 */

    case 182:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USAmode
   && reload_completed))
        return -1;
      return 2058; /* *fractdausa2 */

    case 183:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode
   && reload_completed))
        return -1;
      return 2059; /* *fractudausa2 */

    case 184:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USAmode
   && reload_completed))
        return -1;
      return 2060; /* *fracttausa2 */

    case 185:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode
   && reload_completed))
        return -1;
      return 2061; /* *fractutausa2 */

    case 186:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != USAmode
   && reload_completed))
        return -1;
      return 2062; /* *fractqiusa2 */

    case 187:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != USAmode
   && reload_completed))
        return -1;
      return 2063; /* *fracthiusa2 */

    case 188:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != USAmode
   && reload_completed))
        return -1;
      return 2064; /* *fractsiusa2 */

    case 189:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != USAmode
   && reload_completed))
        return -1;
      return 2065; /* *fractdiusa2 */

    case 190:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DQmode
   && reload_completed))
        return -1;
      return 2066; /* *fractqqdq2 */

    case 191:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode
   && reload_completed))
        return -1;
      return 2067; /* *fractuqqdq2 */

    case 192:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DQmode
   && reload_completed))
        return -1;
      return 2068; /* *fracthqdq2 */

    case 193:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode
   && reload_completed))
        return -1;
      return 2069; /* *fractuhqdq2 */

    case 194:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DQmode
   && reload_completed))
        return -1;
      return 2070; /* *fracthadq2 */

    case 195:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode
   && reload_completed))
        return -1;
      return 2071; /* *fractuhadq2 */

    case 196:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DQmode
   && reload_completed))
        return -1;
      return 2072; /* *fractsqdq2 */

    case 197:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DQmode
   && reload_completed))
        return -1;
      return 2073; /* *fractusqdq2 */

    case 198:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DQmode
   && reload_completed))
        return -1;
      return 2074; /* *fractsadq2 */

    case 199:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DQmode
   && reload_completed))
        return -1;
      return 2075; /* *fractusadq2 */

    case 200:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode
   && reload_completed))
        return -1;
      return 2076; /* *fractudqdq2 */

    case 201:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DQmode
   && reload_completed))
        return -1;
      return 2077; /* *fractdadq2 */

    case 202:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode
   && reload_completed))
        return -1;
      return 2078; /* *fractudadq2 */

    case 203:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DQmode
   && reload_completed))
        return -1;
      return 2079; /* *fracttadq2 */

    case 204:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode
   && reload_completed))
        return -1;
      return 2080; /* *fractutadq2 */

    case 205:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DQmode
   && reload_completed))
        return -1;
      return 2081; /* *fractqidq2 */

    case 206:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DQmode
   && reload_completed))
        return -1;
      return 2082; /* *fracthidq2 */

    case 207:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DQmode
   && reload_completed))
        return -1;
      return 2083; /* *fractsidq2 */

    case 208:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != DQmode
   && reload_completed))
        return -1;
      return 2084; /* *fractdidq2 */

    case 209:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode
   && reload_completed))
        return -1;
      return 2085; /* *fractqqudq2 */

    case 210:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode
   && reload_completed))
        return -1;
      return 2086; /* *fractuqqudq2 */

    case 211:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode
   && reload_completed))
        return -1;
      return 2087; /* *fracthqudq2 */

    case 212:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode
   && reload_completed))
        return -1;
      return 2088; /* *fractuhqudq2 */

    case 213:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode
   && reload_completed))
        return -1;
      return 2089; /* *fracthaudq2 */

    case 214:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode
   && reload_completed))
        return -1;
      return 2090; /* *fractuhaudq2 */

    case 215:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode
   && reload_completed))
        return -1;
      return 2091; /* *fractsqudq2 */

    case 216:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode
   && reload_completed))
        return -1;
      return 2092; /* *fractusqudq2 */

    case 217:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode
   && reload_completed))
        return -1;
      return 2093; /* *fractsaudq2 */

    case 218:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode
   && reload_completed))
        return -1;
      return 2094; /* *fractusaudq2 */

    case 219:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode
   && reload_completed))
        return -1;
      return 2095; /* *fractdqudq2 */

    case 220:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode
   && reload_completed))
        return -1;
      return 2096; /* *fractdaudq2 */

    case 221:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode
   && reload_completed))
        return -1;
      return 2097; /* *fractudaudq2 */

    case 222:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode
   && reload_completed))
        return -1;
      return 2098; /* *fracttaudq2 */

    case 223:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode
   && reload_completed))
        return -1;
      return 2099; /* *fractutaudq2 */

    case 224:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDQmode
   && reload_completed))
        return -1;
      return 2100; /* *fractqiudq2 */

    case 225:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDQmode
   && reload_completed))
        return -1;
      return 2101; /* *fracthiudq2 */

    case 226:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDQmode
   && reload_completed))
        return -1;
      return 2102; /* *fractsiudq2 */

    case 227:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDQmode
   && reload_completed))
        return -1;
      return 2103; /* *fractdiudq2 */

    case 228:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DAmode
   && reload_completed))
        return -1;
      return 2104; /* *fractqqda2 */

    case 229:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode
   && reload_completed))
        return -1;
      return 2105; /* *fractuqqda2 */

    case 230:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DAmode
   && reload_completed))
        return -1;
      return 2106; /* *fracthqda2 */

    case 231:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode
   && reload_completed))
        return -1;
      return 2107; /* *fractuhqda2 */

    case 232:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DAmode
   && reload_completed))
        return -1;
      return 2108; /* *fracthada2 */

    case 233:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode
   && reload_completed))
        return -1;
      return 2109; /* *fractuhada2 */

    case 234:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DAmode
   && reload_completed))
        return -1;
      return 2110; /* *fractsqda2 */

    case 235:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DAmode
   && reload_completed))
        return -1;
      return 2111; /* *fractusqda2 */

    case 236:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DAmode
   && reload_completed))
        return -1;
      return 2112; /* *fractsada2 */

    case 237:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DAmode
   && reload_completed))
        return -1;
      return 2113; /* *fractusada2 */

    case 238:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DAmode
   && reload_completed))
        return -1;
      return 2114; /* *fractdqda2 */

    case 239:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode
   && reload_completed))
        return -1;
      return 2115; /* *fractudqda2 */

    case 240:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode
   && reload_completed))
        return -1;
      return 2116; /* *fractudada2 */

    case 241:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DAmode
   && reload_completed))
        return -1;
      return 2117; /* *fracttada2 */

    case 242:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode
   && reload_completed))
        return -1;
      return 2118; /* *fractutada2 */

    case 243:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DAmode
   && reload_completed))
        return -1;
      return 2119; /* *fractqida2 */

    case 244:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DAmode
   && reload_completed))
        return -1;
      return 2120; /* *fracthida2 */

    case 245:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DAmode
   && reload_completed))
        return -1;
      return 2121; /* *fractsida2 */

    case 246:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != DAmode
   && reload_completed))
        return -1;
      return 2122; /* *fractdida2 */

    case 247:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode
   && reload_completed))
        return -1;
      return 2123; /* *fractqquda2 */

    case 248:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode
   && reload_completed))
        return -1;
      return 2124; /* *fractuqquda2 */

    case 249:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode
   && reload_completed))
        return -1;
      return 2125; /* *fracthquda2 */

    case 250:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode
   && reload_completed))
        return -1;
      return 2126; /* *fractuhquda2 */

    case 251:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode
   && reload_completed))
        return -1;
      return 2127; /* *fracthauda2 */

    case 252:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode
   && reload_completed))
        return -1;
      return 2128; /* *fractuhauda2 */

    case 253:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode
   && reload_completed))
        return -1;
      return 2129; /* *fractsquda2 */

    case 254:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode
   && reload_completed))
        return -1;
      return 2130; /* *fractusquda2 */

    case 255:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode
   && reload_completed))
        return -1;
      return 2131; /* *fractsauda2 */

    case 256:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode
   && reload_completed))
        return -1;
      return 2132; /* *fractusauda2 */

    case 257:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode
   && reload_completed))
        return -1;
      return 2133; /* *fractdquda2 */

    case 258:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode
   && reload_completed))
        return -1;
      return 2134; /* *fractudquda2 */

    case 259:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode
   && reload_completed))
        return -1;
      return 2135; /* *fractdauda2 */

    case 260:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode
   && reload_completed))
        return -1;
      return 2136; /* *fracttauda2 */

    case 261:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode
   && reload_completed))
        return -1;
      return 2137; /* *fractutauda2 */

    case 262:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDAmode
   && reload_completed))
        return -1;
      return 2138; /* *fractqiuda2 */

    case 263:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDAmode
   && reload_completed))
        return -1;
      return 2139; /* *fracthiuda2 */

    case 264:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDAmode
   && reload_completed))
        return -1;
      return 2140; /* *fractsiuda2 */

    case 265:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDAmode
   && reload_completed))
        return -1;
      return 2141; /* *fractdiuda2 */

    case 266:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != TAmode
   && reload_completed))
        return -1;
      return 2142; /* *fractqqta2 */

    case 267:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode
   && reload_completed))
        return -1;
      return 2143; /* *fractuqqta2 */

    case 268:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != TAmode
   && reload_completed))
        return -1;
      return 2144; /* *fracthqta2 */

    case 269:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode
   && reload_completed))
        return -1;
      return 2145; /* *fractuhqta2 */

    case 270:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != TAmode
   && reload_completed))
        return -1;
      return 2146; /* *fracthata2 */

    case 271:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode
   && reload_completed))
        return -1;
      return 2147; /* *fractuhata2 */

    case 272:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != TAmode
   && reload_completed))
        return -1;
      return 2148; /* *fractsqta2 */

    case 273:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != TAmode
   && reload_completed))
        return -1;
      return 2149; /* *fractusqta2 */

    case 274:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != TAmode
   && reload_completed))
        return -1;
      return 2150; /* *fractsata2 */

    case 275:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != TAmode
   && reload_completed))
        return -1;
      return 2151; /* *fractusata2 */

    case 276:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != TAmode
   && reload_completed))
        return -1;
      return 2152; /* *fractdqta2 */

    case 277:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode
   && reload_completed))
        return -1;
      return 2153; /* *fractudqta2 */

    case 278:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != TAmode
   && reload_completed))
        return -1;
      return 2154; /* *fractdata2 */

    case 279:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode
   && reload_completed))
        return -1;
      return 2155; /* *fractudata2 */

    case 280:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode
   && reload_completed))
        return -1;
      return 2156; /* *fractutata2 */

    case 281:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != TAmode
   && reload_completed))
        return -1;
      return 2157; /* *fractqita2 */

    case 282:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != TAmode
   && reload_completed))
        return -1;
      return 2158; /* *fracthita2 */

    case 283:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != TAmode
   && reload_completed))
        return -1;
      return 2159; /* *fractsita2 */

    case 284:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != TAmode
   && reload_completed))
        return -1;
      return 2160; /* *fractdita2 */

    case 285:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode
   && reload_completed))
        return -1;
      return 2161; /* *fractqquta2 */

    case 286:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode
   && reload_completed))
        return -1;
      return 2162; /* *fractuqquta2 */

    case 287:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode
   && reload_completed))
        return -1;
      return 2163; /* *fracthquta2 */

    case 288:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode
   && reload_completed))
        return -1;
      return 2164; /* *fractuhquta2 */

    case 289:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode
   && reload_completed))
        return -1;
      return 2165; /* *fracthauta2 */

    case 290:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode
   && reload_completed))
        return -1;
      return 2166; /* *fractuhauta2 */

    case 291:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode
   && reload_completed))
        return -1;
      return 2167; /* *fractsquta2 */

    case 292:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode
   && reload_completed))
        return -1;
      return 2168; /* *fractusquta2 */

    case 293:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode
   && reload_completed))
        return -1;
      return 2169; /* *fractsauta2 */

    case 294:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode
   && reload_completed))
        return -1;
      return 2170; /* *fractusauta2 */

    case 295:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode
   && reload_completed))
        return -1;
      return 2171; /* *fractdquta2 */

    case 296:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode
   && reload_completed))
        return -1;
      return 2172; /* *fractudquta2 */

    case 297:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode
   && reload_completed))
        return -1;
      return 2173; /* *fractdauta2 */

    case 298:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode
   && reload_completed))
        return -1;
      return 2174; /* *fractudauta2 */

    case 299:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode
   && reload_completed))
        return -1;
      return 2175; /* *fracttauta2 */

    case 300:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != UTAmode
   && reload_completed))
        return -1;
      return 2176; /* *fractqiuta2 */

    case 301:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != UTAmode
   && reload_completed))
        return -1;
      return 2177; /* *fracthiuta2 */

    case 302:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != UTAmode
   && reload_completed))
        return -1;
      return 2178; /* *fractsiuta2 */

    case 303:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != UTAmode
   && reload_completed))
        return -1;
      return 2179; /* *fractdiuta2 */

    case 304:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != QImode
   && reload_completed))
        return -1;
      return 2180; /* *fractqqqi2 */

    case 305:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QImode
   && reload_completed))
        return -1;
      return 2181; /* *fractuqqqi2 */

    case 306:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QImode
   && reload_completed))
        return -1;
      return 2182; /* *fracthqqi2 */

    case 307:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QImode
   && reload_completed))
        return -1;
      return 2183; /* *fractuhqqi2 */

    case 308:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QImode
   && reload_completed))
        return -1;
      return 2184; /* *fracthaqi2 */

    case 309:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QImode
   && reload_completed))
        return -1;
      return 2185; /* *fractuhaqi2 */

    case 310:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QImode
   && reload_completed))
        return -1;
      return 2186; /* *fractsqqi2 */

    case 311:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QImode
   && reload_completed))
        return -1;
      return 2187; /* *fractusqqi2 */

    case 312:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QImode
   && reload_completed))
        return -1;
      return 2188; /* *fractsaqi2 */

    case 313:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QImode
   && reload_completed))
        return -1;
      return 2189; /* *fractusaqi2 */

    case 314:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QImode
   && reload_completed))
        return -1;
      return 2190; /* *fractdqqi2 */

    case 315:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QImode
   && reload_completed))
        return -1;
      return 2191; /* *fractudqqi2 */

    case 316:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QImode
   && reload_completed))
        return -1;
      return 2192; /* *fractdaqi2 */

    case 317:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QImode
   && reload_completed))
        return -1;
      return 2193; /* *fractudaqi2 */

    case 318:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QImode
   && reload_completed))
        return -1;
      return 2194; /* *fracttaqi2 */

    case 319:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QImode
   && reload_completed))
        return -1;
      return 2195; /* *fractutaqi2 */

    case 320:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != QImode
   && reload_completed))
        return -1;
      return 2196; /* *fracthiqi2 */

    case 321:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != QImode
   && reload_completed))
        return -1;
      return 2197; /* *fractsiqi2 */

    case 322:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != QImode
   && reload_completed))
        return -1;
      return 2198; /* *fractdiqi2 */

    case 323:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HImode
   && reload_completed))
        return -1;
      return 2199; /* *fractqqhi2 */

    case 324:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HImode
   && reload_completed))
        return -1;
      return 2200; /* *fractuqqhi2 */

    case 325:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HImode
   && reload_completed))
        return -1;
      return 2201; /* *fracthqhi2 */

    case 326:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HImode
   && reload_completed))
        return -1;
      return 2202; /* *fractuhqhi2 */

    case 327:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HImode
   && reload_completed))
        return -1;
      return 2203; /* *fracthahi2 */

    case 328:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HImode
   && reload_completed))
        return -1;
      return 2204; /* *fractuhahi2 */

    case 329:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HImode
   && reload_completed))
        return -1;
      return 2205; /* *fractsqhi2 */

    case 330:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HImode
   && reload_completed))
        return -1;
      return 2206; /* *fractusqhi2 */

    case 331:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HImode
   && reload_completed))
        return -1;
      return 2207; /* *fractsahi2 */

    case 332:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HImode
   && reload_completed))
        return -1;
      return 2208; /* *fractusahi2 */

    case 333:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HImode
   && reload_completed))
        return -1;
      return 2209; /* *fractdqhi2 */

    case 334:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HImode
   && reload_completed))
        return -1;
      return 2210; /* *fractudqhi2 */

    case 335:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HImode
   && reload_completed))
        return -1;
      return 2211; /* *fractdahi2 */

    case 336:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HImode
   && reload_completed))
        return -1;
      return 2212; /* *fractudahi2 */

    case 337:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HImode
   && reload_completed))
        return -1;
      return 2213; /* *fracttahi2 */

    case 338:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HImode
   && reload_completed))
        return -1;
      return 2214; /* *fractutahi2 */

    case 339:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != HImode
   && reload_completed))
        return -1;
      return 2215; /* *fractqihi2 */

    case 340:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != HImode
   && reload_completed))
        return -1;
      return 2216; /* *fractsihi2 */

    case 341:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != HImode
   && reload_completed))
        return -1;
      return 2217; /* *fractdihi2 */

    case 342:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SImode
   && reload_completed))
        return -1;
      return 2218; /* *fractqqsi2 */

    case 343:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SImode
   && reload_completed))
        return -1;
      return 2219; /* *fractuqqsi2 */

    case 344:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SImode
   && reload_completed))
        return -1;
      return 2220; /* *fracthqsi2 */

    case 345:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SImode
   && reload_completed))
        return -1;
      return 2221; /* *fractuhqsi2 */

    case 346:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SImode
   && reload_completed))
        return -1;
      return 2222; /* *fracthasi2 */

    case 347:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SImode
   && reload_completed))
        return -1;
      return 2223; /* *fractuhasi2 */

    case 348:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SImode
   && reload_completed))
        return -1;
      return 2224; /* *fractsqsi2 */

    case 349:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SImode
   && reload_completed))
        return -1;
      return 2225; /* *fractusqsi2 */

    case 350:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SImode
   && reload_completed))
        return -1;
      return 2226; /* *fractsasi2 */

    case 351:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SImode
   && reload_completed))
        return -1;
      return 2227; /* *fractusasi2 */

    case 352:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SImode
   && reload_completed))
        return -1;
      return 2228; /* *fractdqsi2 */

    case 353:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SImode
   && reload_completed))
        return -1;
      return 2229; /* *fractudqsi2 */

    case 354:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SImode
   && reload_completed))
        return -1;
      return 2230; /* *fractdasi2 */

    case 355:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SImode
   && reload_completed))
        return -1;
      return 2231; /* *fractudasi2 */

    case 356:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SImode
   && reload_completed))
        return -1;
      return 2232; /* *fracttasi2 */

    case 357:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SImode
   && reload_completed))
        return -1;
      return 2233; /* *fractutasi2 */

    case 358:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != SImode
   && reload_completed))
        return -1;
      return 2234; /* *fractqisi2 */

    case 359:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != SImode
   && reload_completed))
        return -1;
      return 2235; /* *fracthisi2 */

    case 360:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DImode != SImode
   && reload_completed))
        return -1;
      return 2236; /* *fractdisi2 */

    case 361:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DImode
   && reload_completed))
        return -1;
      return 2237; /* *fractqqdi2 */

    case 362:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DImode
   && reload_completed))
        return -1;
      return 2238; /* *fractuqqdi2 */

    case 363:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DImode
   && reload_completed))
        return -1;
      return 2239; /* *fracthqdi2 */

    case 364:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DImode
   && reload_completed))
        return -1;
      return 2240; /* *fractuhqdi2 */

    case 365:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DImode
   && reload_completed))
        return -1;
      return 2241; /* *fracthadi2 */

    case 366:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DImode
   && reload_completed))
        return -1;
      return 2242; /* *fractuhadi2 */

    case 367:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DImode
   && reload_completed))
        return -1;
      return 2243; /* *fractsqdi2 */

    case 368:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DImode
   && reload_completed))
        return -1;
      return 2244; /* *fractusqdi2 */

    case 369:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DImode
   && reload_completed))
        return -1;
      return 2245; /* *fractsadi2 */

    case 370:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DImode
   && reload_completed))
        return -1;
      return 2246; /* *fractusadi2 */

    case 371:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DImode
   && reload_completed))
        return -1;
      return 2247; /* *fractdqdi2 */

    case 372:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DImode
   && reload_completed))
        return -1;
      return 2248; /* *fractudqdi2 */

    case 373:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DImode
   && reload_completed))
        return -1;
      return 2249; /* *fractdadi2 */

    case 374:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DImode
   && reload_completed))
        return -1;
      return 2250; /* *fractudadi2 */

    case 375:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DImode
   && reload_completed))
        return -1;
      return 2251; /* *fracttadi2 */

    case 376:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DImode
   && reload_completed))
        return -1;
      return 2252; /* *fractutadi2 */

    case 377:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(QImode != DImode
   && reload_completed))
        return -1;
      return 2253; /* *fractqidi2 */

    case 378:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(HImode != DImode
   && reload_completed))
        return -1;
      return 2254; /* *fracthidi2 */

    case 379:
      if (!
#line 75 "../../gcc/config/avr/avr-fixed.md"
(SImode != DImode
   && reload_completed))
        return -1;
      return 2255; /* *fractsidi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      switch (pattern93 (x1))
        {
        case 0:
          if (!(
#line 10133 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10135 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_666 (insn, operands);

        case 1:
          if (!(
#line 10509 "../../gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0) && 
#line 10512 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_742 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern181 (x2))
        {
        case 0:
          if (
#line 10387 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_720 (insn, operands);
          break;

        case 1:
          if (
#line 10387 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_721 (insn, operands);
          break;

        case 2:
          if (
#line 10387 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_722 (insn, operands);
          break;

        case 3:
          if (
#line 10387 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_723 (insn, operands);
          break;

        case 4:
          return gen_split_724 (insn, operands);

        case 5:
          return gen_split_725 (insn, operands);

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return NULL;
      switch (pattern139 (x1))
        {
        case 0:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_730 (insn, operands);

        case 1:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_734 (insn, operands);

        case 2:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_738 (insn, operands);

        case 3:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_731 (insn, operands);

        case 4:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_735 (insn, operands);

        case 5:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_739 (insn, operands);

        case 6:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_732 (insn, operands);

        case 7:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_736 (insn, operands);

        case 8:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_740 (insn, operands);

        case 9:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_733 (insn, operands);

        case 10:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_737 (insn, operands);

        case 11:
          if (!(
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10492 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_741 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      if (pattern94 (x1) != 0
          || !
#line 10441 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_726 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_24 (x1, insn);

    case PLUS:
      return split_25 (x1, insn);

    case MINUS:
      return split_26 (x1, insn);

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != REG)
            return NULL;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          switch (REGNO (x5))
            {
            case 24:
              if (pattern281 (x1) != 0
                  || !(
#line 2239 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2241 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_163 (insn, operands);

            case 22:
              if (pattern282 (x1) != 0
                  || !(
#line 3715 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3717 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_335 (insn, operands);

            case 18:
              switch (pattern283 (x1))
                {
                case 0:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1824 (insn, operands);

                case 1:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1825 (insn, operands);

                case 2:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1826 (insn, operands);

                case 3:
                  if (!(
#line 425 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1827 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern182 (x1) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2994 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2996 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_298 (insn, operands);
          if (u8_operand (operands[2], E_HImode)
              && (
#line 3030 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3032 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_301 (insn, operands);
          if (!o8_operand (operands[2], E_HImode)
              || !(
#line 3048 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3050 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_302 (insn, operands);

        case ZERO_EXTEND:
          if (pattern182 (x1) != 0)
            return NULL;
          if (u8_operand (operands[2], E_HImode)
              && (
#line 2994 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2996 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_299 (insn, operands);
          if (!s8_operand (operands[2], E_HImode)
              || !(
#line 3012 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3014 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_300 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      return split_27 (x1, insn);

    case TRUNCATE:
      if (GET_MODE (x4) != E_HImode
          || pattern183 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != MULT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 22
              || GET_MODE (x8) != E_HImode)
            return NULL;
          switch (pattern358 (x9))
            {
            case 0:
              if (!(
#line 3800 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3802 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_339 (insn, operands);

            case 1:
              if (!(
#line 3800 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3802 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        case CLZ:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 22
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 26
              || GET_MODE (x8) != E_QImode
              || !
#line 9405 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_647 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4509 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_368 (insn, operands);

        case 1:
          if (!
#line 4543 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_369 (insn, operands);

        case 2:
          if (!
#line 4578 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_370 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4657 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_372 (insn, operands);

        case 1:
          if (!
#line 4689 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_373 (insn, operands);

        case 2:
          if (!
#line 4721 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_374 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4778 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_376 (insn, operands);

        case 1:
          if (!
#line 4808 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_377 (insn, operands);

        case 2:
          if (!
#line 4840 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (pattern252 (x1))
        {
        case 0:
          if ((
#line 5232 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5237 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_403 (insn, operands);
          if (!(
#line 5255 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!(
#line 5232 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5237 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 2:
          if (!(
#line 5255 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 3:
          if (!(
#line 5255 "../../gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_406 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern253 (x1))
            {
            case 0:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_435 (insn, operands);
              break;

            case 1:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_438 (insn, operands);
              break;

            case 2:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return gen_split_441 (insn, operands);
              break;

            case 3:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_444 (insn, operands);
              break;

            case 4:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_447 (insn, operands);
              break;

            case 5:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_450 (insn, operands);
              break;

            case 6:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_453 (insn, operands);
              break;

            case 7:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_456 (insn, operands);
              break;

            case 8:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_459 (insn, operands);
              break;

            case 9:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_462 (insn, operands);
              break;

            case 10:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_465 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern254 (x1) != 0
          || !
#line 6029 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_532 (insn, operands);

    case ASHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern253 (x1))
            {
            case 0:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_436 (insn, operands);
              break;

            case 1:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_439 (insn, operands);
              break;

            case 2:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return gen_split_442 (insn, operands);
              break;

            case 3:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_445 (insn, operands);
              break;

            case 4:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_448 (insn, operands);
              break;

            case 5:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_451 (insn, operands);
              break;

            case 6:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_454 (insn, operands);
              break;

            case 7:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_457 (insn, operands);
              break;

            case 8:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_460 (insn, operands);
              break;

            case 9:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_463 (insn, operands);
              break;

            case 10:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_466 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern254 (x1) != 0
          || !
#line 5829 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_511 (insn, operands);

    case LO_SUM:
      if (GET_MODE (x4) != E_PSImode
          || pattern171 (x1) != 0
          || !
#line 6634 "../../gcc/config/avr/avr.md"
(reload_completed))
        return NULL;
      return gen_split_560 (insn, operands);

    case COMPARE:
      if (GET_MODE (x4) != E_CCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return NULL;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 36
          || GET_MODE (x7) != E_CCmode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != SCRATCH
          || GET_MODE (x8) != E_QImode)
        return NULL;
      switch (pattern323 (x5))
        {
        case 0:
          if (!(
#line 6908 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_566 (insn, operands);

        case 1:
          if (!(
#line 6908 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_567 (insn, operands);

        case 2:
          if (!(
#line 6908 "../../gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_568 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x4, 0);
      if (!ordered_comparison_operator (x5, E_VOIDmode))
        return NULL;
      operands[0] = x5;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return NULL;
      x11 = XEXP (x4, 2);
      if (GET_CODE (x11) != PC)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern289 (x1))
        {
        case 0:
          if (
#line 7016 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_572 (insn, operands);
          break;

        case 1:
          if (
#line 7016 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_573 (insn, operands);
          break;

        case 2:
          if (
#line 7016 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_574 (insn, operands);
          break;

        case 3:
          if (
#line 7016 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_575 (insn, operands);
          break;

        case 4:
          if (
#line 7016 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_576 (insn, operands);
          break;

        case 5:
          if (
#line 7043 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_577 (insn, operands);
          break;

        case 6:
          if (
#line 7071 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_578 (insn, operands);
          break;

        case 7:
          if (
#line 7071 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_579 (insn, operands);
          break;

        case 8:
          if (
#line 7071 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_580 (insn, operands);
          break;

        case 9:
          if (
#line 7071 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_581 (insn, operands);
          break;

        case 10:
          if (
#line 7071 "../../gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_582 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != REG)
        return NULL;
      switch (pattern290 (x1))
        {
        case 0:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1928 (insn, operands);

        case 1:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1929 (insn, operands);

        case 2:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1930 (insn, operands);

        case 3:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1931 (insn, operands);

        case 4:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1932 (insn, operands);

        case 5:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1933 (insn, operands);

        case 6:
          if (!(
#line 555 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1934 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return NULL;
      switch (pattern225 (x1))
        {
        case 0:
          if (!(
#line 9140 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9142 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_635 (insn, operands);

        case 1:
          if (!(
#line 9169 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9171 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PARITY
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 9155 "../../gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9157 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_636 (insn, operands);

    case CLZ:
      if (pattern156 (x1) != 0
          || !
#line 9384 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_646 (insn, operands);

    case CTZ:
      if (pattern156 (x1) != 0
          || !
#line 9453 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_648 (insn, operands);

    case FFS:
      if (pattern156 (x1) != 0
          || !
#line 9525 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_650 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return NULL;
      x12 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x12) != REG)
        return NULL;
      x13 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x13) != REG
          || GET_MODE (x13) != E_QImode)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      switch (pattern293 (x1))
        {
        case 0:
          if (!(
#line 9729 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9731 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_654 (insn, operands);

        case 1:
          if (!(
#line 9801 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9803 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_656 (insn, operands);

        case 2:
          if (!(
#line 9873 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9875 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_658 (insn, operands);

        case 3:
          if (!
#line 716 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 4:
          if (!
#line 716 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1857 (insn, operands);

        case 5:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1858 (insn, operands);

        case 6:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1859 (insn, operands);

        case 7:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1860 (insn, operands);

        case 8:
          if (!
#line 742 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1861 (insn, operands);

        case 9:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 10:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1863 (insn, operands);

        case 11:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1864 (insn, operands);

        case 12:
          if (!
#line 768 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1865 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1832 (insn, operands);

        default:
          return NULL;
        }

    case DIV:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1833 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
